#include "DataManagerProxy.h"
#include "RedisClient.h"
DataManagerProxy::DataManagerProxy() {

}

QList<DataManagerInfo> DataManagerProxy::loadModuleInfos(const char* id, const char* app)
{

    RedisClient* redis = new RedisClient();
    QList<DataManagerInfo > listDataManageInfo;
    QString key = QString("%1:%2").arg(app).arg(id);
    DeviceInfo di;
    if( redis != nullptr)
    {
        QStringList lst = redis->hvals(key);
        foreach (QString str, lst)
        {
            if( str.isEmpty() )
            {
                continue;
            }
            ModuleInfo mi;
            mi.Name = "RedisSubscriber";

            mi.AssemblyName = "plugins/RedisSubscriber.dll";
            mi.ClassName = "RedisSubscriber";

            ConsumerInfo ci;

            ci.name = "TDengine";

            ci.AssemblyName = "plugins/TDengine.dll";
            ci.ClassName = "TDengine";
            ci.SubscribeName = "RedisSubscriber";
            DataManagerInfo dataManageInfo;
            dataManageInfo.consumers.push_back(ci);
            dataManageInfo.modules.push_back(mi);
            listDataManageInfo.push_back(dataManageInfo);

        }
    }

    //return di;


    return listDataManageInfo;
}
